part of pdf;

/// Represents an annotation object with holds link on another location within a document.
class PdfDocumentLinkAnnotation extends PdfLinkAnnotation {
  // constructor
  /// Initializes new [PdfDocumentLinkAnnotation] instance with specified bounds and destination.
  PdfDocumentLinkAnnotation(Rect bounds, PdfDestination destination)
      : super(bounds) {
    ArgumentError.checkNotNull(destination, 'destination');
    this.destination = destination;
  }

  // fields
  PdfDestination _destination;

  // properties
  /// Gets the destination of the annotation.
  PdfDestination get destination => _destination;

  /// Sets the destination of the annotation.
  set destination(PdfDestination value) {
    ArgumentError.checkNotNull(value, 'destibation');
    if (value != _destination) {
      _destination = value;
    }
  }

  // implementation
  @override
  void _save() {
    super._save();
    if (_destination != null) {
      _dictionary.setProperty(
          _PdfName(_DictionaryProperties.dest), _destination._element);
    }
  }

  @override
  _IPdfPrimitive _element;
}
