part of pdf;

class _PdfReferenceHolder implements _IPdfPrimitive {
  _PdfReferenceHolder(dynamic obj) {
    ArgumentError.checkNotNull(obj, 'obj');
    if (obj is _IPdfWrapper) {
      object = obj._element;
    } else if (obj is _IPdfPrimitive) {
      object = obj;
    } else {
      throw ArgumentError.value(
          'argument is not set to an instance of an object');
    }
  }

  //Fields
  _IPdfPrimitive object;
  _PdfReference reference;
  bool _isSaving;
  int _objectCollectionIndex;
  int _position;
  _ObjectStatus _status;

  //_IPdfPrimitive members
  @override
  bool get isSaving {
    _isSaving ??= false;
    return _isSaving;
  }

  @override
  set isSaving(bool value) {
    _isSaving = value;
  }

  @override
  int get objectCollectionIndex {
    _objectCollectionIndex ??= 0;
    return _objectCollectionIndex;
  }

  @override
  set objectCollectionIndex(int value) {
    _objectCollectionIndex = value;
  }

  @override
  int get position {
    _position ??= -1;
    return _position;
  }

  @override
  set position(int value) {
    _position = value;
  }

  @override
  _ObjectStatus get status {
    _status ??= _ObjectStatus.none;
    return _status;
  }

  @override
  set status(_ObjectStatus value) {
    _status = value;
  }

  @override
  _IPdfPrimitive clonedObject;

  @override
  void save(_IPdfWriter writer) {
    ArgumentError.checkNotNull(writer, 'writer');
    object.isSaving = true;
    final _PdfCrossTable crossTable = writer._document._crossTable;
    final _PdfReference reference = crossTable._getReference(object);
    reference.save(writer);
  }

  @override
  void dispose() {
    if (reference != null) {
      reference.dispose();
      reference = null;
    }
    if (_status != null) {
      _status = null;
    }
  }
}
